Description

Hi,

| just tried to compile Exiv2 using CMake and it didn't work on my Windows machine using VS2012. For some reason my Windows
couldn't execute the svn_version.shfile...
On the other hand, that batch file generates a svn_version.h file which seems to be mandatory in the src/CMakeLists.txt file.

There may be different approaches to this problem:

- create and include a default "svn_version.h" file.

- replace the .sh hack with proper CMake commands. As | already suggested in #858 you can use FIND_PACKAGE(Subversion)
and related commands

- don't require svn_version.h for Windows/CMake compilation

Best,
Daniel

Related issues:
Related to Exiv2 - Bug #994: CMake: wrong build rule for svn_version.h Closed 09 Oct 2014

Associated revisions

Revision 3364 - 16 Sep 2014 14:15 - Robin Mills

Issue: #991 (Windows build broken (CMake+svn_version.sh). Thank You, Daniel for the patch.

History

#1 - 15 Sep 2014 14:52 - Robin Mills

- Status changed from New to Assigned

- Assignee set to Robin Mills

- Priority changed from Urgent to Normal

Daniel

I've just run a CMake build with MSVC 2005 and that does not attempt to execute svn_version.sh

When | added the feature to include the svn revision in to the the build of Exiv2, | decided that this would not be supported by MSVC. So the code to
generate the svn_version.h should not be executed for MSVC builds. So in CMakelLists.txt, you'll find:

IF ( NOT MSVC )

MESSAGE (STATUS "generating ${CMAKE_CURRENT_SOURCE_DIR}/src/svn_version.h")

EXECUTE_PROCESS ( WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src COMMAND ./svn_version.sh)
ENDIF ()

And in version.hpp:

// svn version has not been implemented yet for DevStudio
#if defined (_MSC_VER)

#define SVN_VERSION 0

#else

#include "svn_version.h"

#endif

So I'm surprised this is causing you difficulty, as | believe | have engineered things correctly. Are you working on the trunk?
https://dev.exiv2.org/issues/858

The reason to omit svn for MSVC is the dependency on locating svn.exe. The svn version number feature is intended for development purposes to
differentiate different branches and builds. So for MSVC | report svn=0.

MSVC builds can't execute svn_version.sh because it's a bash script and intended for not MSVC environments (cygwin/mingw/linux/macosx).

I'll have to back-track and learn about FIND_PACKAGE(Subversion). As you know, I'm not strong with CMake and don't understand the FIND magic.
However, it's important for me to master this as we're about to introduce more optional libraries to support the WebReady feature in v0.25.

You will be pleased to learn that we're developing a Jenkins build server for Exiv2. One of the challenges of Exiv2 is the size of the build/test matrix.
Having a machine dedicated to building in response to commits will significantly improve our day-to-day build/test coverage. | purchased a Mac-Mini
which runs the Virtual Machines running Windows and Linux in addition to the being a native Mac. | only acquired the machine 5 weeks ago and it's
work in progress at the moment. http:/exiv2.dyndns.org:8080

#2 - 16 Sep 2014 00:22 - Gilles Caulier
Robin,

Typically, you don't need to use a bash script to handle svn version ID.
This is how we do it with cmake about git version ID. There are 2 files :

https://projects.kde.org/projects/extragear/graphics/digikam/repository/revisions/master/entry/cmake/templates/qgitscript.cmake.in

This is the cmake script which run git binary with right option to get last commit ID.

https://projects.kde.org/projects/extragear/graphics/digikam/repository/revisions/master/entry/cmake/templates/qitversion.h.cmake.in
This is the header file patched by previous cmake script to register git ID

In the past, digiKam has used svn, and we have handle svn commit ID by a similar way. But i cannot found relevant file in git history.
This can be certainly found in old digiKam archive. This kind of cmake script must be located in core/cmake/templates dir.

Note : it's always a good id to look in digiKam cmake code if a problem have not been already managed in the past. We have plenty of cmake code
where you can find a good inspiration for Exiv2

Gilles
#3 - 16 Sep 2014 01:15 - Robin Mills
Thanks, Gilles

You are always very helpful. For sure the FIND_PROGRAM magic in CMake looks very useful. | appreciate that DigiKam and other projects are
much more experienced in CMake. | have much to learn about CMake, as you know.

We build with ./configure and CMake. So the script svn_version.sh is invoked from either environment to update the file svn_version.h when the svn
has been updated. | don't use svn_version.h at all in MSVC builds.

I'm not convinced that Exiv2 has a bug here. Let's wait for Daniel's comments. | believe he will be able to build successfully with CMake.
Robin
#4 - 16 Sep 2014 14:09 - Daniel Kaneider
- File exiv2-cmake-svn-version.patch added
Hi Robin,
sorry that | didn't make it clear. CMake already failed in my case with the following error
CMake Error at src/CMakeLists.txt:191 (ADD_LIBRARY) :

Cannot find source file:

svn_version.h

You were also right, that there is some special handling in the main CMakeLists file and in the .cpp regarding this file for msvc. However, the
src/Cmakelists.txt always tries to include the svn_version.h file. | wonder how this could work in your case. Im using 3358, and my error is confirmed

by the repository at http:/dev.exiv2.org/projects/exiv2/repository/show/trunk/src where there is no svn_version.h file. Did you maybe use a non-clean
source directory?

Anyway, with the small change, similar to the other places | fixed that place. Appending you find the patch. With that, | was able to compile to make
an in-source build using VS 2012-x64. Sadly in-source, but thats another story you already know...

Thanks
Daniel

#5 - 16 Sep 2014 14:32 - Robin Mills
- Status changed from Assigned to Resolved

- Target version set to 0.25

Thank You, Daniel. Yes - you are 100% correct. I've submitted your patch r3364. Thank You for working on this - and thanks for pushing to get to
the bottom of this. I'm going to mark this "Resolved".

The MSVC build/test has been rather badly broken r3355 .. r3358. My submission r3359 should restore stability.

I've recruited a new build engineer Nehal Wani and hope he'll be able to spend more time on our CMake support next year. As you know, there are
many things to deal with in a software project and limited resources and skills. So, while | regret that our CMake support is weak, | try my best to
keep everything moving forward. When we have the Jenkins build server fully operational, perhaps with 2 build engineers on the project, we'll can
improve our CMake support.

You are right to be suspicious that a dirty build tree could contain a version of svn_version.h from an earlier ./configure build. The Jenkins build does
a "make distclean” on every build. At the moment, we haven't added the code for Jenkins to build using CMake - however we intend to do so.

Thank You once more for your contribution to Exiv2.

#6 - 08 May 2015 16:13 - Robin Mills
- % Done changed from 0 to 100

#7 - 21 Jun 2015 16:41 - Andreas Huggel

- Status changed from Resolved to Closed

Files

exiv2-cmake-svn-version.patch 770 Bytes 16 Sep 2014 Daniel Kaneider
